/* Generated by MyraPad at 03/09/2021 17:13:57 */
using Myra.Graphics2D.Brushes;
using Myra.Graphics2D.UI;
using System;
using System.Threading.Tasks;

namespace Sledgemapper.UI
{
	public partial class MapList
	{
        public CommunicationManager CommunicationManager { get; }

        public MapList(CommunicationManager communicationManager)
		{
            CommunicationManager= communicationManager;
			BuildUI();
            BtnNewCampaign.Click += (s, e) =>
            {
                OnMenuMapNew(s, e);
                this.GetContainingWindow().Close();
            };
        }

        public async Task LoadMaps()
        {
            var campaigns = await CommunicationManager.Api.GetMaps(State.Instance.CampaignName);
            foreach (var campaign in campaigns)
            {
                var item = new ListItem();
                item.ItemName.Text = campaign.SessionName;
                item.TouchUp += OnMapSelected;
                StackCampaignsList.AddChild(item);
            }
        }

        private void OnMapSelected(object sender, EventArgs e)
        {
            var item = sender as ListItem;
            var localContent = item.GetParentContentInWindow<Widget>();

            var list = item.Parent as Grid;
            for (var i = 0; i < list.ChildrenCount; i++)
            {
                var currentItem = list.GetChild(i) as HorizontalStackPanel;// UI.ListItem;
                currentItem.Background = new SolidBrush("#D9D9D9FF");
            }
            item.Background = new SolidBrush(Settings.Instance.OverlayTintColor);
        }

        private void OnMenuMapNew(object sender, EventArgs e)
        {
            new MapWindow(CommunicationManager).ShowInModalWindow(Desktop, "New map");
        }
    }
}